summaryrefslogtreecommitdiffstats
path: root/audio/jack
diff options
context:
space:
mode:
Diffstat (limited to 'audio/jack')
-rw-r--r--audio/jack/README34
-rw-r--r--audio/jack/jack.SlackBuild173
-rw-r--r--audio/jack/jack.info12
-rw-r--r--audio/jack/jack2vsjack1.txt67
-rw-r--r--audio/jack/setcap.sh5
-rw-r--r--audio/jack/slack-desc19
6 files changed, 310 insertions, 0 deletions
diff --git a/audio/jack/README b/audio/jack/README
new file mode 100644
index 0000000000..24c1a96773
--- /dev/null
+++ b/audio/jack/README
@@ -0,0 +1,34 @@
+jack (realtime low-latency sound server)
+
+JACK is a system for handling real-time, low latency audio and MIDI.
+It can connect a number of different applications to an audio device,
+as well as allowing them to share audio between themselves.
+
+Its clients can run in their own processes (ie. as normal apps), or
+within the JACK server (ie. as a "plugin"). JACK also has support for
+distributing audio processing across a network, both fast & reliable
+LANs as well as slower, less reliable WANs.
+
+This package includes both jack and jack-example-tools.
+
+Note: This build conflicts with jack1: install only one of the two.
+JACK's developers recommend not using jack1 at all, although it's still
+maintained.
+
+Note: this build was formerly known as jack2. Before installing this,
+"removepkg jack2" if you had it installed.
+
+SBo build maintainers, please list jack (not jack1) as a dependency for
+your builds. If the software you're trying to build really does work
+with jack1 but not jack, please contact the jack maintainer (currently
+B. Watson <urchlay@slackware.uk>. Include the build log and any runtime
+error messages in your email, plase.
+
+This package uses POSIX filesystem capabilities to execute with
+elevated privileges (required for realtime audio processing). This
+may be considered a security/stability risk. Please read
+http://www.slackbuilds.org/caps/ for more information. To disable
+capabilities, pass SETCAP=no to the script.
+
+Optional dependencies are celt, libffado, zita-alsa-pcmi, and
+zita-resampler.
diff --git a/audio/jack/jack.SlackBuild b/audio/jack/jack.SlackBuild
new file mode 100644
index 0000000000..30fde24f08
--- /dev/null
+++ b/audio/jack/jack.SlackBuild
@@ -0,0 +1,173 @@
+#!/bin/bash
+
+# Slackware build script for jack (formerly jack2).
+
+# Copyright 2014 Yanes Checcacci Balod <email removed>, Brazil
+# Copyright 2014-2015 Marcel Saegebarth <email removed>
+# Copyright 2018 B. Watson <urchlay@slackware.uk>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# 20230511 bkw: update for v1.9.22. upstream split the tools off into
+# a separate repo, I modified this script to build them and include them
+# in this package (like PV does with vim and ctags).
+# 20220614 bkw: update for v1.9.21 and 15.0.
+# 20210802 bkw: update for v1.9.19 and -current.
+# 20210304 bkw: update for v1.9.17.
+# 20201104 bkw: update for v1.9.16.
+# 20200118 bkw: renamed from 'jack2' to 'jack'. If you want to see
+# the old log: "git log -- audio/jack2"
+# 20200112 bkw: get rid of --profile (thanks, dive!), BUILD=2.
+# 20191201 bkw: update for v1.9.14 (including new python3 dep).
+# 20180714 bkw:
+# - Take over maintenance.
+# - Update for v1.9.12.
+# - Move HTML docs to proper Slackware doc dir.
+# - i486 => i586.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=jack
+VERSION=${VERSION:-1.9.22}
+TOOLSVER=${TOOLSVER:-4}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+SRCNAM=jack2
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i586"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-$VERSION
+tar xvf $CWD/$SRCNAM-$VERSION.tar.gz
+cd $SRCNAM-$VERSION
+TOPDIR="$(pwd)"
+tar xvf $CWD/jack-example-tools-$TOOLSVER.tar.gz
+chown -R root:root .
+find -L . -perm /111 -a \! -perm 755 -a -exec chmod 755 {} \+ -o \
+ \! -perm /111 -a \! -perm 644 -a -exec chmod 644 {} \+
+
+# Minor source of incompatibility between jack 1.x and 2.x: some jack
+# apps don't add -lpthread to their CFLAGS because they assume jack.pc
+# will already include it (it does, in 1.x). So make 2 act like 1:
+sed -i '/^Libs:/s,$, -lpthread,' jack.pc.in
+
+# 20220614 bkw: upstream disabled the tools by default in 1.9.21, way
+# to handle a point release... --example-tools turns it back on.
+# 20230511 bkw: aaand in 1.9.22, they removed the tools entirely. Again,
+# way to handle a point release...
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+LDFLAGS="-Wl,-s" \
+./waf configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man/man1 \
+ --htmldir=/usr/doc/$PRGNAM-$VERSION/html \
+ --classic \
+ --dbus \
+ --alsa
+
+./waf build
+./waf install --destdir=$PKG
+
+# 20230511 bkw: now build the tools against the installed libs in $PKG.
+cd $TOPDIR
+sed "s,/usr,$PKG/usr,g" $PKG/usr/lib$LIBDIRSUFFIX/pkgconfig/jack.pc > jack.pc
+export PKG_CONFIG_PATH=$TOPDIR:$PKG_CONFIG_PATH
+cd jack-example-tools-$TOOLSVER
+mkdir build
+MFLAGS="$SLKCFLAGS -I$PKG/usr/include"
+cd build
+ CFLAGS="$MFLAGS" \
+ CXXFLAGS="$MFLAGS" \
+ LDFLAGS="-L$PKG/usr/lib$LIBDIRSUFFIX" \
+ meson .. \
+ --buildtype=release \
+ --infodir=/usr/info \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --prefix=/usr \
+ --sysconfdir=/etc \
+ -Dstrip=true
+ "${NINJA:=ninja}"
+ DESTDIR=$PKG $NINJA install
+cd ..
+
+gzip $PKG/usr/man/man?/*
+
+PKGDOC=$PKG/usr/doc/$PRGNAM-$VERSION
+PKGDOC2=$PKGDOC/jack-example-tools-$TOOLSVER
+mkdir -p $PKGDOC2
+cp -a LICENSE *.md $PKGDOC2
+cd $TOPDIR
+cp -a AUTHORS* COPYING* ChangeLog* README* $PKGDOC
+cat $CWD/$PRGNAM.SlackBuild > $PKGDOC/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+# Only add capability stuff if not disabled:
+if [ "${SETCAP:-yes}" = "yes" ]; then
+ # 20230719 bkw: dynamically create the list instead of hardcoding.
+ # there's at least one symlink, hence find and xargs.
+ BINS="$( cd $PKG/usr/bin && find * -type l -o -print | xargs echo )"
+ sed "s,@BINS@,$BINS," < $CWD/setcap.sh >> $PKG/install/doinst.sh
+ # Only allow execution by audio group
+ chown root:audio $PKG/usr/bin/*
+ chmod 0750 $PKG/usr/bin/*
+fi
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/audio/jack/jack.info b/audio/jack/jack.info
new file mode 100644
index 0000000000..9567dbac3f
--- /dev/null
+++ b/audio/jack/jack.info
@@ -0,0 +1,12 @@
+PRGNAM="jack"
+VERSION="1.9.22"
+HOMEPAGE="http://jackaudio.org/"
+DOWNLOAD="https://github.com/jackaudio/jack2/archive/v1.9.22/jack2-1.9.22.tar.gz \
+ https://github.com/jackaudio/jack-example-tools/archive/4/jack-example-tools-4.tar.gz"
+MD5SUM="e57c8ad3de75f78b6eb7aacea4e25755 \
+ 282f4c913489b32edc9926c8f84a73ae"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="B. Watson"
+EMAIL="urchlay@slackware.uk"
diff --git a/audio/jack/jack2vsjack1.txt b/audio/jack/jack2vsjack1.txt
new file mode 100644
index 0000000000..931855528a
--- /dev/null
+++ b/audio/jack/jack2vsjack1.txt
@@ -0,0 +1,67 @@
+20200119 bkw: The default jack version on SlackBuilds.org is now 1.9.14,
+aka JACK2. The old 0.125.0 version (formerly jack-audio-connection-kit)
+is still available as "jack1". The JACK2 build used to be called "jack2",
+and has been renamed to simply "jack". SBo maintainers take note: please
+don't list jack1 in REQUIRES for your builds. If your build really does
+work only with jack1 and fails with jack, please contact me (B. Watson,
+urchlay@slackware.uk) and let me know the details.
+
+This information might be helpful in understanding the differences
+between jack and jack1.
+
+jack and jack1 are API compatible enough that applications can be built
+against either, and in fact most (possibly all?) apps can be built
+against one and run with the other with no problems.
+
+jack1 wasn't designed to benefit from multiple CPU cores/threads. It may
+(or may not) offer slightly better performance on single-core systems.
+
+jack no longer supports jack1's "-Z" flag.
+
+When using -Xseq with jack, connect your ALSA MIDI devices to the system
+"MIDI thru" port, then connect that port to the JACK midi capture
+port. This is an extra step that isn't necessary with jack1.
+
+jack stores a persistent "registry" and database in /dev/shm, which
+is intended to speed up jack startup and allow multiple jack servers
+on the same host to cooperate. There is one small issue with this:
+if jackd can't write to /dev/shm/jack_db/, it will fail to start
+(segfault). If this happens, make sure jackd is not running, and "rm
+-rf /dev/shm/jack*". This only happens when jackd is used by different
+users, which means most of us will be unaffected by it. Upstream has
+been notified, and a fix is being worked on.
+
+Original README from the old jack2 package has some possibly outdated
+info on the differences between 1 and 2:
+
+jackdmp (aka JACK2) is a C++ version of the JACK low-latency audio
+server for multi-processor machines. It is a new implementation
+of the JACK server core features that aims in removing some
+limitations of the JACK1 design. The activation system has been
+changed for a data flow model and lock-free programming techniques
+for graph access have been used to have a more dynamic and
+robust system.
+
+- jackdmp use a new client activation model that allows simultaneous
+client execution (on a smp machine) when parallel clients exist
+in the graph (client that have the same inputs). This activation model
+allows to better use available CPU on a smp machine, but also works
+on a mono-processor machine.
+
+- jackdmp use a lock-free way to access (read/write) the client graph,
+thus allowing connections/disconnection to be done without
+interrupting the audio stream. The result is that
+connections/disconnections are glitch-free.
+
+- jackdmp can work in 2 different modes at the server level :
+ - synchronous activation : in a given cycle, the server waits for
+ all clients to be finished (similar to normal jackd)
+ - asynchronous activation : in a given cycle, the server does not
+ wait for all clients to be finished and use output buffer
+ computed the previous cycle.
+
+The audible result of this mode is that if a client is not activated
+during one cycle, other clients may still run and the resulting audio
+stream will still be produced (even if its partial in some way).
+This mode usually result in fewer (less audible) audio glitches in a
+loaded system.
diff --git a/audio/jack/setcap.sh b/audio/jack/setcap.sh
new file mode 100644
index 0000000000..4a3331efd0
--- /dev/null
+++ b/audio/jack/setcap.sh
@@ -0,0 +1,5 @@
+if [ -x /sbin/setcap ]; then
+ for i in @BINS@; do
+ /sbin/setcap cap_ipc_lock,cap_sys_nice=ep usr/bin/$i
+ done
+fi
diff --git a/audio/jack/slack-desc b/audio/jack/slack-desc
new file mode 100644
index 0000000000..ee8df1b978
--- /dev/null
+++ b/audio/jack/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+jack: jack (realtime low-latency sound server)
+jack:
+jack: JACK is a system for handling real-time, low latency audio and MIDI.
+jack: It can connect a number of different applications to an audio device,
+jack: as well as allowing them to share audio between themselves.
+jack:
+jack: Its clients can run in their own processes (ie. as normal apps), or
+jack: within the JACK server (ie. as a "plugin"). JACK also has support
+jack: for distributing audio processing across a network, both fast &
+jack: reliable LANs as well as slower, less reliable WANs.
+jack: